import _extends from "@babel/runtime/helpers/extends";
// eslint-disable-next-line import/no-extraneous-dependencies
import React, { useEffect, useState } from 'react';
import { useDashboard } from './react';
export const PageLink = _ref => {
  let {
    destination,
    onClick,
    children,
    ...otherHtmlProps
  } = _ref;
  const sdk = useDashboard();
  const [href, setHref] = useState();
  useEffect(() => {
    let isEffectStillRelevant = true;
    const urlPromise = sdk.getPageUrl(destination);
    urlPromise.then(url => isEffectStillRelevant && setHref(url));
    return () => {
      isEffectStillRelevant = false;
    };
    // eslint-disable-next-line react-hooks/exhaustive-deps
  }, [destination]);
  const handleClick = clickEvent => {
    if (onClick) {
      onClick(clickEvent);
    }
    if (!clickEvent.defaultPrevented) {
      clickEvent.preventDefault();
      sdk.navigate(destination);
    }
  };
  return /*#__PURE__*/React.createElement("a", _extends({}, otherHtmlProps, {
    href: href,
    onClick: handleClick
  }), children);
};
//# sourceMappingURL=PageLink.js.map