import _extends from "@babel/runtime/helpers/extends";
// eslint-disable-next-line import/no-extraneous-dependencies
import React, { useEffect, useState } from 'react';
// eslint-disable-next-line import/no-extraneous-dependencies
import { WixProvider } from '@wix/sdk-react';
import { dashboard } from '@wix/dashboard';
export const withDashboard = Component => {
  return ownPropsWithHost => {
    const {
      host: maybeGivenHost,
      ...ownProps
    } = ownPropsWithHost;
    const {
      host,
      props: hostProps
    } = useHostAndProps(ownPropsWithHost.host);
    const [auth] = useState(dashboard.auth);
    if (!host || !hostProps) {
      return null;
    }
    return /*#__PURE__*/React.createElement(WixProvider, {
      host: host,
      auth: auth
    }, /*#__PURE__*/React.createElement(Component, _extends({}, hostProps, ownProps)));
  };
};
const useHostAndProps = localHost => {
  const [remoteHost, setRemoteHost] = useState();
  const [remoteHostProps, setRemoteHostProps] = useState();
  useEffect(() => {
    if (localHost) {
      return;
    }
    const _remoteHost = dashboard.host();
    setRemoteHost(_remoteHost);
    const observeState = _remoteHost.channel.observeState; // casting is needed because typescript couldn't handle it by itself
    const observeResult = observeState(newObservedProps => {
      setRemoteHostProps(newObservedProps);
    });
    const cleanup = async () => {
      setRemoteHost(undefined);
      setRemoteHostProps(undefined);
      (await observeResult).disconnect();
      _remoteHost.close();
    };
    return () => {
      cleanup();
    };
  }, [localHost]);
  return localHost ? {
    host: localHost,
    props: {}
  } : {
    host: remoteHost,
    props: remoteHostProps
  };
};
//# sourceMappingURL=withDashboard.js.map